/**
 * The remote interface for a persistent object.
 */
package imaginary.persist;

import imaginary.util.RemoteObservable;
import java.rmi.RemoteException;

public interface RemotePersistent extends RemoteObservable {
    public abstract boolean isDeleted() throws RemoteException;

    public abstract boolean isLocked() throws RemoteException;

    public abstract boolean isModified() throws RemoteException;

    public abstract boolean isNew() throws RemoteException;

    public abstract boolean isSaving() throws RemoteException;

    public abstract int getId() throws RemoteException;

    public abstract void setNew() throws RemoteException;

    public abstract void remove(RemoteLockHolder h)
    throws LockException, RemoteException;
}
