/**
 * Remote interface for the Observable class.
 */
package imaginary.util;

import java.io.Serializable;
import java.rmi.Remote;
import java.rmi.RemoteException;

public interface RemoteObservable extends Remote {
    public abstract void addObserver(RemoteObserver ob) throws RemoteException;

    public abstract void deleteObserver(RemoteObserver ob)
    throws RemoteException;

    public abstract int countObservers() throws RemoteException;
    
    public abstract void notifyObservers() throws RemoteException;

    public abstract void notifyObservers(Remote arg)
    throws RemoteException;

    public abstract void notifyObservers(Serializable arg)
    throws RemoteException;

    public abstract boolean hasChanged() throws RemoteException;
}
